#version 330 core

uniform sampler2D srcTex;
uniform sampler2D noiseTex;

in vec4 texCoord1;

out vec4 fragColor;

uniform float blurKernel[BLUR_KERNEL_SIZE];
uniform float blurStep;

void main()
{
	float step = blurStep * texture(noiseTex, gl_FragCoord.xy / 64.0).r;
	vec4 sum = vec4(0.0);
	vec2 dt = vec2(-step * (BLUR_KERNEL_SIZE-1), 0.0);
	for(int i = BLUR_KERNEL_SIZE-1; i > 0; i--)
	{
		vec4 val = texture(srcTex, texCoord1.xy + dt) - 1.0;
		sum += blurKernel[i] * val;
		dt.x += step;
	}
	for(int i = 0; i < BLUR_KERNEL_SIZE; i++)
	{
		vec4 val = texture(srcTex, texCoord1.xy + dt) - 1.0;
		sum += blurKernel[i] * val;
		dt.x += step;
	}
	fragColor = sum;
}