#version 330 core

uniform vec4 perspective;

float linearizeDepth(float d)
{
    float zN = 2.0 * d - 1.0;
    return -2.0 * perspective.x * perspective.y / (perspective.y + perspective.x - zN * (perspective.y - perspective.x));
}

float unlinearizeDepth(float d)
{
    float zN = (2.0 * perspective.x * perspective.y / d + perspective.y + perspective.x) / (perspective.y - perspective.x);
    return (zN + 1.0) / 2.0;
}

vec4 getViewSpacePosition(vec2 texCoord, float linearDepth)
{
    vec2 halfNDC = vec2(0.5) - texCoord;
    return vec4(halfNDC * perspective.zw * linearDepth, linearDepth, 1.0);
}