#version 330 core

#if FOG_TYPE != 0
uniform sampler3D fogTex;
layout(std140) uniform Environment {
	vec4 ambienceAndEmission;
	vec4 envi0ColorAndFactor;
	vec4 envi1Color;
	vec4 fogColor;
	mat4 fogMatrix;
	mat4 viewInv;
};
#endif

in vec4 vertexPosition;
in vec4 vertexTexCoord0;
in vec4 vertexTexCoord1;

out vec4 texCoord0;
out vec4 texCoord1;
#if FOG_TYPE != 0
flat out float eyeFog;
#endif
 
void main(void) 
{
	gl_Position = vertexPosition;
	texCoord0 = vertexTexCoord0;
	texCoord1 = vertexTexCoord1;
#if FOG_TYPE != 0
	vec3 fogCoord = fogMatrix[3].xyz; //Separate statement due to Intel bug
	eyeFog = texture(fogTex, fogCoord).r;
#endif
}