#version 330 core

uniform sampler2DArray colorTex;
uniform sampler2DArray emissionTex;
uniform sampler2DArray rgmaTex;
uniform sampler2DArray normalTex;

uniform vec4 emission;
uniform vec4 rgma;

in vec4 position;
in vec3 normal;
in vec3 tangent;
in vec3 bitangent;
in vec4 texCoord0;
in vec4 color;

out vec4 fragColor;

vec3 lightFragment(vec4 position, vec3 normal, vec4 color, vec3 emission, vec4 rgma, float fragDepth);

void main()
{
	vec3 matNormal = 2.0 * (texture(normalTex, texCoord0.xyz).rgb - 0.5);
	matNormal = (matNormal.x * tangent + matNormal.y * bitangent + matNormal.z * normal);
	vec4 matColor = texture(colorTex, texCoord0.xyz) * color;
	vec3 matEmission = texture(emissionTex, texCoord0.xyz).rgb * emission.rgb;
	vec4 matRGMA = texture(rgmaTex, texCoord0.xyz) * rgma;

	fragColor = vec4(lightFragment(position, matNormal, matColor, matEmission, matRGMA, gl_FragCoord.z), matColor.a);
}