#version 330 core

uniform sampler2DArray colorTex;

uniform vec4 emission;
uniform vec4 rgma;

in vec4 position;
in vec3 normal;
in vec4 texCoord0;
in vec4 color;

out vec4 fragColor;

vec3 lightFragment(vec4 position, vec3 normal, vec4 color, vec3 emission, vec4 rgma, float fragDepth);

void main()
{
	vec4 matColor = texture(colorTex, texCoord0.xyz) * color;
	fragColor = vec4(lightFragment(position, normal, matColor, emission.rgb, rgma, gl_FragCoord.z), matColor.a);
}